/* $Header: d:/cvsroot/tads/html/win32/tadsreg.h,v 1.1.1.1 1999/05/09 21:32:31 MJRoberts Exp $ */

/* Copyright (c) 1997 by Michael J. Roberts.  All Rights Reserved. */
/*
Name
  tadsreg.h - registry operations
Function
  
Notes
  
Modified
  10/28/97 MJRoberts  - Creation
*/

#ifndef TADSREG_H
#define TADSREG_H

#include <windows.h>

#ifndef TADSHTML_H
#include "tadshtml.h"
#endif

class CTadsRegistry
{
public:
    /* 
     *   open a registry key; if 'create' is true, we'll create the key if
     *   it's not already present 
     */
    static HKEY open_key(HKEY base_key, const textchar_t *key_name,
                         DWORD *disposition, int create);

    /* close a key */
    static void close_key(HKEY key);

    /* check if a value is set in the registry */
    static int value_exists(HKEY key, const textchar_t *valname);

    /* get a key's value */
    static long query_key_long(HKEY key, const textchar_t *valname);
    static size_t query_key_str(HKEY key, const textchar_t *valname,
                                textchar_t *buf, size_t bufsiz);
    static int query_key_bool(HKEY key, const textchar_t *valname);
    static size_t query_key_binary(HKEY key, const textchar_t *valname,
                                   void *buf, size_t bufsiz);

    /* set a key's value */
    static void set_key_long(HKEY key, const textchar_t *valname, long val);
    static void set_key_str(HKEY key, const textchar_t *valname,
                            const textchar_t *str, size_t len);
    static void set_key_bool(HKEY key, const textchar_t *valname, int val);
    static void set_key_binary(HKEY key, const textchar_t *valname,
                               void *buf, size_t bufsiz);

private:
    static int query_key(HKEY key, const textchar_t *valname,
                         textchar_t *buf, size_t *bufsiz);
};

#endif /* TADSREG_H */

