/* $Header: d:/cvsroot/tads/html/win32/w32img.h,v 1.1.1.1 1999/05/09 21:32:32 MJRoberts Exp $ */

/* Copyright (c) 1998 by Michael J. Roberts.  All Rights Reserved. */
/*
Name
  w32img.h - tads html win32 image implementation
Function
  
Notes
  
Modified
  01/31/98 MJRoberts  - Creation
*/

#ifndef W32IMG_H
#define W32IMG_H

#ifndef TADSJPEG_H
#include "tadsjpeg.h"
#endif
#ifndef TADSPNG_H
#include "tadspng.h"
#endif
#ifndef HTMLSYS_H
#include "htmlsys.h"
#endif


/* ------------------------------------------------------------------------ */
/*
 *   JPEG Image implementation 
 */
class CHtmlSysImageJpeg_win32: public CTadsJpeg, public CHtmlSysImageJpeg
{
public:
    /*
     *   CHtmlSysImageJpeg implementation 
     */

    /* load a JPEG image */
    int load_from_jpeg(class CHtmlJpeg *jpeg)
    {
        return CTadsJpeg::load_from_jpeg(jpeg);
    }

    /* display the image */
    void draw_image(class CHtmlSysWin *win, class CHtmlRect *pos);

    /* map the palette */
    int map_palette(class CHtmlSysWin *win, int foreground);

    /* get the dimensions */
    unsigned long get_width() const { return width_; }
    unsigned long get_height() const { return height_; }
};

/*
 *   PNG Image implementation 
 */
class CHtmlSysImagePng_win32: public CTadsPng, public CHtmlSysImagePng
{
public:
    /*
     *   CHtmlSysImagePng implementation 
     */

    /* load a PNG image */
    int load_from_png(class CHtmlPng *png)
    {
        return CTadsPng::load_from_png(png);
    }

    /* display the image */
    void draw_image(class CHtmlSysWin *win, class CHtmlRect *pos);

    /* map the palette */
    int map_palette(class CHtmlSysWin *win, int foreground);

    /* get the dimensions */
    unsigned long get_width() const { return width_; }
    unsigned long get_height() const { return height_; }
};


#endif /* W32IMG_H */
